dpkg-source(1)

NAME
dpkg-source - Debian source package (.dsc) manipulation tool

SYNOPSIS
dpkg-source [options] command

DESCRIPTION
dpkg-source packs and unpacks Debian source archives. None of these commands allow multiple options to be combined into one, and they do not allow the value for an option to be specified in a separate argument.

COMMANDS

-x filename.dsc [output-directory]
    Extract a source package. One non-option argument must be supplied, the name of the Debian source control file (.dsc). An optional second non-option argument may be supplied to specify the directory to extract the source package to, this must not exist. If no output directory is specified, the source package is extracted into a directory named source-version under the current working directory. dpkg-source will read the names of the other file(s) making up the source package from the control file; they are assumed to be in the same directory as the .dsc. The files in the extracted package will have their permissions and ownerships set to those which would have been expected if the files and directories had simply been created - directories and executable files will be 0777 and plain files will be 0666, both modified by the extractors' umask; if the parent directory is setgid then the extracted directories will be too, and all the files and directories will inherit its group ownership.

-b [options] directory [orig-directory|orig-targz|'']
    Build a source package. One or two non-option arguments should be supplied. The first is taken as the name of the directory containing the unpacked source tree. If a second argument is supplied it should be the name of the original source directory or tarfile or the empty string if the package is a Debian-specific one and so has no Debianisation diffs. If no second argument is supplied then dpkg-source will look for the original source tarfile package_upstream-version.orig.tar.gz or the original source directory directory.orig depending on the -sX arguments.

-h, --help
    Show the usage message and exit.

--version
    Show the version and exit.

OPTIONS

-ccontrolfile
    Specifies the main source control file to read information from. The default is debian/control. If given with relative pathname this is interpreted starting at the source tree's top level directory.

-lchangelogfile
    Specifies the change log file to read information from. The default is debian/changelog. If given with relative pathname this is interpreted starting at the source tree's top level directory.

-Fchangelogformat
    Specifies the format of the changelog. By default the format is read from a special line near the bottom of the changelog or failing that defaults to the debian standard format.

-Vname=value
    Set an output substitution variable. See deb-substvars(5) for a discussion of output substitution.

-Tsubstvarsfile
    Read substitution variables in substvarsfile; the default is debian/substvars.

-Dfield=value
    Override or add an output control file field.

-Ufield
    Remove an output control file field.

-W  This option turns certain errors into warnings.

-E  This option negates a previously set -W.

-i[regexp]
    You may specify a perl regular expression to match files you want filtered out of the list of files for the diff. (This list is generated by a find command.) -i by itself enables the option, with a default that will filter out control files and directories of the most common revision control systems, backup and swap files and Libtool build output directories. This is very helpful in cutting out extraneous files that get included in the .diff.gz, (eg: "debian/BUGS_TODO/*" or "debian/RCS/*,v"). For instance, if you maintain a package that you track via remote CVS, where you don't have access permissions for committing the debian control files and making tags for cvs-buildpackage(1), it is necessary to perform an extra checkout/update into a directory you keep pristine, to generate the .orig.tar.gz from. That directory will have CVS/Entries files in it that will contain timestamps that differ from the ones in your working directory, thus causing them to be unnecessarily included in every .diff.gz, unless you use the -i switch.

-Ifilename
    If this option is specified, the filename will be passed to tar's --exclude option when it is called to generate a .orig.tar.gz or .tar.gz file. For example, -ICVS will make tar skip over CVS directories when generating a .tar.gz file. The option may be repeated multiple times to list multiple filenames to exclude.

All the -sX options are mutually exclusive. If you specify more than one only the last one will be used.

Build options (with -b):

-sa, -sp, -sk, -su and -sr will not overwrite existing tarfiles or directories. If this is desired then -sA, -sP, -sK, -sU and -sR should be used instead.

-sk Specifies to expect the original source as a tarfile, by default package_upstream-version.orig.tar.gz. It will leave this original source in place as a tarfile, or copy it to the current directory if it isn't already there.

-sp Like -sk but will remove that tarball again afterwards.

-su Specifies that the original source is expected as a directory, by default package-upstream-version.orig and dpkg-source will create a new original source archive from it.

-sr Like -su but will remove that directory after it has been used.

-ss Specifies that the original source is available both as a directory and as a tarfile. If will use the directory to create the diff, but the tarfile to create the .dsc. This option must be used with care - if the directory and tarfile do not match a bad source archive will be generated.

-sn Specifies to not look for any original source, and to not generate a diff. The second argument, if supplied, must be the empty string. This is used for Debian-specific packages which do not have a separate upstream source and therefore have no debianisation diffs.

-sa or -sA
    Specifies to look for the original source archive as a tarfile or as a directory - the second argument, if any, may be either, or the empty string (this is equivalent to using -sn). If a tarfile is found it will unpack it to create the diff and remove it afterwards (this is equivalent to -sp); if a directory is found it will pack it to create the original source and remove it afterwards (this is equivalent to -sr); if neither is found it will assume that the package has no debianisation diffs, only a straightforward source archive (this is equivalent to -sn). If both are found then dpkg-source will ignore the directory, overwriting it, if -sA was specified (this is equivalent to -sP) or raise an error if -sa was specified. -sA is the default.

Extract options (with -x):

In all cases any existing original source tree will be removed.

-sp Used when extracting then the original source (if any) will be left as a tarfile. If it is not already located in the current directory or if an existing but different file is there it will be copied there. (This is the default).

-su Unpacks the original source tree.

-sn Ensures that the original source is neither copied to the current directory nor unpacked. Any original source tree that was in the current directory is still removed.

BUGS
The point at which field overriding occurs compared to certain standard output field settings is rather confused. The binary package entries in the debian/files file will be passed through variable substitution twice. This should not matter, since $, { and } are not legal in package names or version numbers.

SEE ALSO
dpkg-deb(1), dpkg(1), dselect(1).

AUTHORS
Copyright (C) 1995-1996 Ian Jackson
Copyright (C) 2000 Wichert Akkerman

This is free software; see the GNU General Public Licence version 2 or later for copying conditions. There is NO WARRANTY.